/// Reutilize Bootstrap mixins to add new responsive modifiers
@each $breakpoint in map-keys($grid-breakpoints) {
  @include media-breakpoint-up($breakpoint) {
    $infix: breakpoint-infix($breakpoint, $grid-breakpoints);

    .border#{$infix}-thick { border-width: 4px !important; }
    .text-decoration#{$infix}-underline { text-decoration: underline !important; }

    .transition#{$infix} {
      @include transition($transition-base);
    }

    .text#{$infix}-nowrap {
      white-space: nowrap;
    }

    .flex-grow#{$infix}-0 {
      flex-grow: 0 !important;
    }

    @each $spacer, $length in $spacers {
      .f#{$infix}-#{$spacer} {
        font-size: $length !important;
      }

      @each $direction in (top, right, bottom, left) {
        .#{$direction}#{$infix}-#{$spacer} { #{$direction}: $length !important; }
        .#{$direction}#{$infix}-n#{$spacer} { #{$direction}: -$length !important; }
      }
    }

    @each $cursor in (pointer, none) {
      .cursor#{$infix}-#{$cursor} {
        cursor: $cursor;
      }
    }

    @each $event in (none, auto) {
      .pointer-event#{$infix}-#{$event} {
        pointer-events: $event;
      }
    }

    @each $position in $positions {
      .position#{$infix}-#{$position} { position: $position !important; }
    }

    .h1#{$infix} { @include font-size($h1-font-size); }
    .h2#{$infix} { @include font-size($h2-font-size); }
    .h3#{$infix} { @include font-size($h3-font-size); }
    .h4#{$infix} { @include font-size($h4-font-size); }
    .h5#{$infix} { @include font-size($h5-font-size); }
    .h6#{$infix} { @include font-size($h6-font-size); }

    $overflows: (auto, hidden, scroll, visible);
    $overflow-axis: (x, y);
    @each $overflow in $overflows {
      .overflow#{$infix}-#{$overflow} {
        overflow: $overflow !important;
      }

      @each $axis in $overflow-axis {
        .overflow-#{$axis}#{$infix}-#{$overflow} {
          overflow-#{$axis}: $overflow !important;
        }
      }
    }

    @each $color, $rgb in $colors {
      .background#{$infix}-#{$color} {
        background-color: $rgb !important;

        &:focus {
          background-color: $rgb !important;
        }
      }

      @each $opacity, $degree in $opacities {
        .background#{$infix}-#{$color}-t#{$opacity} {
          background-color: scale-color($rgb, $alpha: $degree);
        }
      }

      .scrollbar#{$infix}-#{$color} {
        scrollbar-color: var(--#{$color}) transparent;
        scrollbar-width: thin;

        &::-webkit-scrollbar {
          width: 5px;
          height: 8px;
          background-color: transparent;
        }

        &::-webkit-scrollbar-thumb {
          background: var(--#{$color});
        }
      }

      .border#{$infix}-#{$color} {
        border-color: $rgb !important;
      }

      .#{$color} {
        color: $rgb !important;

        &:focus {
          color: $rgb !important;
        }

        ::-moz-selection,
        ::selection {
          background: $rgb;
          color: white;
        }

        mark {
          background-color: $rgb !important;
          color: white !important;
        }
      }
    }

    @each $prop, $abbrev in (width: w, height: h) {
      @each $size, $length in $sizes {
        .#{$abbrev}#{$infix}-#{$size} { #{$prop}: $length !important; }
        .#{$abbrev}#{$infix}-#{$size} { #{$prop}: $length !important; }
        .min-#{$abbrev}#{$infix}-#{$size} { min-#{$prop}: $length !important; }
        .max-#{$abbrev}#{$infix}-#{$size} { max-#{$prop}: $length !important; }
      }
    }
  }
}

/// This creates a navbar that can be toggled on focus and doesn't
/// require CSS.
.navbar-focus-within {
  &:focus-within {
    .navbar-collapse {
      @extend .d-block;
    }
  }

  .dropdown {
    & > .dropdown-menu {
      @extend .d-none;
    }

    &:hover,
    &:focus-within {
      & > .dropdown-menu {
        @extend .d-block;
      }
    }
  }
}
